--
-- TatraAgro
-- 
--

TatraAgro = {};

function TatraAgro.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function TatraAgro:load(xmlFile)

    self.mirrors = {};
    self.mirrors[1] = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.mirrors.mirror1#index"));
    self.mirrors[2] = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.mirrors.mirror2#index"));
    self.drawMirror = getVisibility(self.mirrors[1])

--klakson
    hornSoundFile = Utils.getFilename("sounds/horn.wav", self.baseDirectory);
    self.hornSoundId = createSample("famerCarSound");
    loadSample(self.hornSoundId, hornSoundFile, false);
    self.hornPlaying = false;
--klakson
--blinkr
    turn1SoundFile = Utils.getFilename("sounds/turn1.wav", self.baseDirectory);
    self.turn1SoundId = createSample("turn1Sound");
    loadSample(self.turn1SoundId, turn1SoundFile, false);

    turn2SoundFile = Utils.getFilename("sounds/turn2.wav", self.baseDirectory);
    self.turn2SoundId = createSample("turn2Sound");
    loadSample(self.turn2SoundId, turn2SoundFile, false);

    self.indexeb = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.indexeb#index"));
    self.indexhb = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.indexhb#index"));
    self.indexej = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.indexej#index"));
    self.indexhj = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.indexhj#index"));
    self.indexbActive = false;
    self.indexjActive = false;
    self.flash = false;
    self.flashRight = false;
    self.flashLeft = false;
    self.delayOnLeft = 0;
    self.delayOffLeft = 0;
    self.delayOnRight = 0;
    self.delayOffRight = 0;
    self.delayOn = 0;
    self.delayOff = 0;	
--blinkr
--interior light
	local numinteriorlights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.interiorlights#count"), 0);
    self.interiorlights = {};
    for i=1, numinteriorlights do
        local interiorlightnamei = string.format("vehicle.interiorlights.interiorlight%d", i);
        self.interiorlights[i] = Utils.indexToObject(self.components, getXMLString(xmlFile, interiorlightnamei .. "#index"));
        setVisibility(self.interiorlights[i], false);
    end;
	self.interiorlightsActive = false;
--interior light
--vykyr
	local rotationPartNodevykyr = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.vykyr#index"));
    if rotationPartNodevykyr ~= nil then
        self.rotationPartvykyr = {};
        self.rotationPartvykyr.node = rotationPartNodevykyr;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartvykyr#minRot"));
        self.rotationPartvykyr.minRot = {};
        self.rotationPartvykyr.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartvykyr.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartvykyr.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.vykyr#maxRot"));
        self.rotationPartvykyr.maxRot = {};
        self.rotationPartvykyr.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartvykyr.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartvykyr.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartvykyr.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.vykyr#rotTime"), 2)*1000;
        self.rotationPartvykyr.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.vykyr#touchRotLimit"), 10));
    end;
--vykyr

    self.rotorFan2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotorFan2#index"));

--kabina
	local rotationPartNodekabina = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.kabina#index"));
    if rotationPartNodekabina ~= nil then
        self.rotationPartkabina = {};
        self.rotationPartkabina.node = rotationPartNodekabina;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartkabina#minRot"));
        self.rotationPartkabina.minRot = {};
        self.rotationPartkabina.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartkabina.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartkabina.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kabina#maxRot"));
        self.rotationPartkabina.maxRot = {};
        self.rotationPartkabina.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartkabina.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartkabina.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartkabina.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.kabina#rotTime"), 2)*1000;
        self.rotationPartkabina.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.kabina#touchRotLimit"), 10));
    end;
--kabina

	local rotationPartNodeoknorightsmall = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.oknorightsmall#index"));
    if rotationPartNodeoknorightsmall ~= nil then
        self.rotationPartoknorightsmall = {};
        self.rotationPartoknorightsmall.node = rotationPartNodeoknorightsmall;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartoknorightsmall#minRot"));
        self.rotationPartoknorightsmall.minRot = {};
        self.rotationPartoknorightsmall.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartoknorightsmall.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartoknorightsmall.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.oknorightsmall#maxRot"));
        self.rotationPartoknorightsmall.maxRot = {};
        self.rotationPartoknorightsmall.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartoknorightsmall.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartoknorightsmall.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartoknorightsmall.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.oknorightsmall#rotTime"), 2)*1000;
        self.rotationPartoknorightsmall.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.oknorightsmall#touchRotLimit"), 10));
    end;

	local rotationPartNodeoknoleftsmall = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.oknoleftsmall#index"));
    if rotationPartNodeoknoleftsmall ~= nil then
        self.rotationPartoknoleftsmall = {};
        self.rotationPartoknoleftsmall.node = rotationPartNodeoknoleftsmall;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartoknoleftsmall#minRot"));
        self.rotationPartoknoleftsmall.minRot = {};
        self.rotationPartoknoleftsmall.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartoknoleftsmall.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartoknoleftsmall.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.oknoleftsmall#maxRot"));
        self.rotationPartoknoleftsmall.maxRot = {};
        self.rotationPartoknoleftsmall.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartoknoleftsmall.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartoknoleftsmall.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartoknoleftsmall.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.oknoleftsmall#rotTime"), 2)*1000;
        self.rotationPartoknoleftsmall.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.oknoleftsmall#touchRotLimit"), 10));
    end;

	local translationNodeoknoright = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.oknoright#index"));
    if translationNodeoknoright ~= nil then
        self.oknoright = {};
        self.oknoright.node = translationNodeoknoright;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.oknoright#minTrans"));
        self.oknoright.minTrans = {};
        self.oknoright.minTrans[1] = Utils.getNoNil(x, 0);
        self.oknoright.minTrans[2] = Utils.getNoNil(y, 0);
        self.oknoright.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.oknoright#maxTrans"));
        self.oknoright.maxTrans = {};
        self.oknoright.maxTrans[1] = Utils.getNoNil(x, 0);
        self.oknoright.maxTrans[2] = Utils.getNoNil(y, 0);
        self.oknoright.maxTrans[3] = Utils.getNoNil(z, 0);
       self.oknoright.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.oknoright#transTime"), 2)*1000;
    end;

	local translationNodeoknoleft = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.oknoleft#index"));
    if translationNodeoknoleft ~= nil then
        self.oknoleft = {};
        self.oknoleft.node = translationNodeoknoleft;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.oknoleft#minTrans"));
        self.oknoleft.minTrans = {};
        self.oknoleft.minTrans[1] = Utils.getNoNil(x, 0);
        self.oknoleft.minTrans[2] = Utils.getNoNil(y, 0);
        self.oknoleft.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.oknoleft#maxTrans"));
        self.oknoleft.maxTrans = {};
        self.oknoleft.maxTrans[1] = Utils.getNoNil(x, 0);
        self.oknoleft.maxTrans[2] = Utils.getNoNil(y, 0);
        self.oknoleft.maxTrans[3] = Utils.getNoNil(z, 0);
       self.oknoleft.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.oknoleft#transTime"), 2)*1000;
    end;

	local rotationPartNodemaska = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.maska#index"));
    if rotationPartNodemaska ~= nil then
        self.rotationPartmaska = {};
        self.rotationPartmaska.node = rotationPartNodemaska;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartmaska#minRot"));
        self.rotationPartmaska.minRot = {};
        self.rotationPartmaska.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartmaska.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartmaska.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.maska#maxRot"));
        self.rotationPartmaska.maxRot = {};
        self.rotationPartmaska.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartmaska.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartmaska.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartmaska.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.maska#rotTime"), 2)*1000;
        self.rotationPartmaska.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.maska#touchRotLimit"), 10));
    end;

     local rotationPartNoderightdoor = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rightdoor#index"));
    if rotationPartNoderightdoor ~= nil then
        self.rotationPartrightdoor = {};
        self.rotationPartrightdoor.node = rotationPartNoderightdoor;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartrightdoor#minRot"));
        self.rotationPartrightdoor.minRot = {};
        self.rotationPartrightdoor.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartrightdoor.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartrightdoor.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rightdoor#maxRot"));
        self.rotationPartrightdoor.maxRot = {};
        self.rotationPartrightdoor.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartrightdoor.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartrightdoor.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartrightdoor.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rightdoor#rotTime"), 2)*1000;
        self.rotationPartrightdoor.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rightdoor#touchRotLimit"), 10));
    end;
	
	 local rotationPartNodeleftDoor = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.leftDoor#index"));
    if rotationPartNodeleftDoor ~= nil then
        self.rotationPartleftDoor = {};
        self.rotationPartleftDoor.node = rotationPartNodeleftDoor;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartleftDoor#minRot"));
        self.rotationPartleftDoor.minRot = {};
        self.rotationPartleftDoor.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartleftDoor.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartleftDoor.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.leftDoor#maxRot"));
        self.rotationPartleftDoor.maxRot = {};
        self.rotationPartleftDoor.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartleftDoor.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartleftDoor.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartleftDoor.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.leftDoor#rotTime"), 2)*1000;
        self.rotationPartleftDoor.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.leftDoor#touchRotLimit"), 10));
    end;

    -- Engine
    self.startMotor = SpecializationUtil.callSpecializationsFunction("startMotor");
    self.stopMotor = SpecializationUtil.callSpecializationsFunction("stopMotor");
    self.startRefuel = SpecializationUtil.callSpecializationsFunction("startRefuel");
    self.stopRefuel = SpecializationUtil.callSpecializationsFunction("stopRefuel");
    self.setFuelFillLevel = SpecializationUtil.callSpecializationsFunction("setFuelFillLevel");


    self.fuelCapacity = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fuelCapacity"), 500);
    self.fuelUsage = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fuelUsage"), 0.01);


    self.hasRefuelStationInRange = false;
    self.doRefuel = false;
    self:setFuelFillLevel(self.fuelCapacity);

    self.refuelSampleRunning = false;
    self.refuelSample = createSample("refuelSample");
    loadSample(self.refuelSample, "data/maps/sounds/refuel.wav", false);

    local motorMinRpm = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motor#minRpm"), 1000);
    local motorMaxRpmStr = getXMLString(xmlFile, "vehicle.motor#maxRpm");
    local motorMaxRpm1, motorMaxRpm2, motorMaxRpm3 = Utils.getVectorFromString(motorMaxRpmStr);
    motorMaxRpm1 = Utils.getNoNil(motorMaxRpm1, 800);
    motorMaxRpm2 = Utils.getNoNil(motorMaxRpm2, 1000);
    motorMaxRpm3 = Utils.getNoNil(motorMaxRpm3, 1800);
    local motorMaxRpm = {motorMaxRpm1, motorMaxRpm2, motorMaxRpm3};
    self.motorMaxRpmLimit = {motorMaxRpm1, motorMaxRpm2, motorMaxRpm3};
    local motorTorque = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motor#torque"), 15);
    local brakeForce = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motor#brakeForce"), 10)*2;
    local forwardGearRatioStr = getXMLString(xmlFile, "vehicle.motor#forwardGearRatio");
    local forwardGearRatio1, forwardGearRatio2, forwardGearRatio3 = Utils.getVectorFromString(forwardGearRatioStr);
    forwardGearRatio1 = Utils.getNoNil(forwardGearRatio1, 2);
    forwardGearRatio2 = Utils.getNoNil(forwardGearRatio2, forwardGearRatio1);
    forwardGearRatio3 = Utils.getNoNil(forwardGearRatio3, forwardGearRatio2);
    local forwardGearRatios = {forwardGearRatio1, forwardGearRatio2, forwardGearRatio3};
    local backwardGearRatio = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motor#backwardGearRatio"), 1.5);
    local differentialRatio = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motor#differentialRatio"), 1);
    local rpmFadeOutRange = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motor#rpmFadeOutRange"), 20);
    local torqueCurve = AnimCurve:new(linearInterpolator1);
    local torqueI = 0;
    while true do
        local key = string.format("vehicle.motor.torque(%d)", torqueI);
        local rpm = getXMLFloat(xmlFile, key.."#rpm");
        local torque = getXMLFloat(xmlFile, key.."#torque");
        if torque == nil or rpm == nil then
            break;
        end;
        torqueCurve:addKeyframe({v=torque*3, time = rpm});
        torqueI = torqueI +1;
    end;
    self.motor = VehicleMotor:new(motorMinRpm, motorMaxRpm, torqueCurve, brakeForce, forwardGearRatios, backwardGearRatio, differentialRatio, rpmFadeOutRange);

    -- Engine sounds
	self.isFadingInMotorSndRun = false;
	self.fadeTime = 4000;
	self.currentFadeTime = 0;
	self.motorSoundActualVolume = 0;

    local motorStartSound = getXMLString(xmlFile, "vehicle.motorStartSound#file");
    if motorStartSound ~= nil and motorStartSound ~= "" then
        motorStartSound = Utils.getFilename(motorStartSound, self.baseDirectory);
        self.motorStartSound = createSample("motorStartSound");
        loadSample(self.motorStartSound, motorStartSound, false);
        self.motorStartSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorStartSound#pitchOffset"), 0);
        self.motorStartSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorStartSound#volume"), 1.0);
    end;

    local motorStopSound = getXMLString(xmlFile, "vehicle.motorStopSound#file");
    if motorStopSound ~= nil and motorStopSound ~= "" then
        motorStopSound = Utils.getFilename(motorStopSound, self.baseDirectory);
        self.motorStopSound = createSample("motorStopSound");
        loadSample(self.motorStopSound, motorStopSound, false);
        self.motorStopSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorStopSound#pitchOffset"), 0);
        self.motorStopSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorStopSound#volume"), 1.0);
    end;
    self.motorStopSoundVolumeBU = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorStopSound#volume"), 1.0);

    local motorSound = getXMLString(xmlFile, "vehicle.motorSound#file");
    if motorSound ~= nil and motorSound ~= "" then
        motorSound = Utils.getFilename(motorSound, self.baseDirectory);
        self.motorSound = createSample("motorSound");
        loadSample(self.motorSound, motorSound, false);
        self.motorSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorSound#pitchOffset"), 0);
        self.motorSoundPitchScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorSound#pitchScale"), 0.05);
        self.motorSoundPitchMax = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorSound#pitchMax"), 2.0);
        self.motorSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorSound#volume"), 1.0);
    end;

    local motorSoundRun = getXMLString(xmlFile, "vehicle.motorSoundRun#file");
    if motorSoundRun ~= nil and motorSoundRun ~= "" then
        motorSoundRun = Utils.getFilename(motorSoundRun, self.baseDirectory);
        self.motorSoundRun = createSample("motorSoundRun");
        loadSample(self.motorSoundRun, motorSoundRun, false);
        self.motorSoundRunPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorSoundRun#pitchOffset"), 0);
        self.motorSoundRunPitchScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorSoundRun#pitchScale"), 0.05);
        self.motorSoundRunPitchMax = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorSoundRun#pitchMax"), 2.0);
        self.motorSoundRunVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorSoundRun#volume"), 1.0);
    end;

    local compressionSound = getXMLString(xmlFile, "vehicle.compressionSound#file");
    if compressionSound ~= nil and compressionSound ~= "" then
        compressionSound = Utils.getFilename(compressionSound, self.baseDirectory);
        self.compressionSound = createSample("compressionSound");
        loadSample(self.compressionSound, compressionSound, false);
        self.compressionSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.compressionSound#pitchOffset"), 1);
        self.compressionSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.compressionSound#volume"), 1);
        self.compressionSoundTime = 0;
        self.compressionSoundEnabled = false;
    end;
    
    local compressedAirSound = getXMLString(xmlFile, "vehicle.compressedAirSound#file");
    if compressedAirSound ~= nil and compressedAirSound ~= "" then
        compressedAirSound = Utils.getFilename(compressedAirSound, self.baseDirectory);
        self.compressedAirSound = createSample("compressedAirSound");
        self.compressedAirSoundEnabled = false;
        loadSample(self.compressedAirSound, compressedAirSound, false);
        self.compressedAirSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.compressedAirSound#pitchOffset"), 1);
        self.compressedAirSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.compressedAirSound#volume"), 1);
    end;
    
    local aiMotorSound  = getXMLString(xmlFile, "vehicle.aiMotorSound#file");
    if aiMotorSound  ~= nil and aiMotorSound  ~= "" then
        aiMotorSound  = Utils.getFilename(aiMotorSound, self.baseDirectory);
        self.aiMotorSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorSoundRun#pitchOffset"), 0);
        self.aiMotorSoundRadius = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorSoundRun#radius"), 50);
        self.aiMotorSoundInnerRadius = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorSoundRun#innerRadius"), 10);
        self.aiMotorSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorSoundRun#volume"), 2);
        self.aiMotorSound = createAudioSource("aiMotorSound", aiMotorSound, self.aiMotorSoundRadius, self.aiMotorSoundInnerRadius, self.aiMotorSoundVolume, 0);
        link(self.components[1].node, self.aiMotorSound);
        setVisibility(self.aiMotorSound, false);
    end;
    
    local reverseDriveSound = getXMLString(xmlFile, "vehicle.reverseDriveSound#file");
    if reverseDriveSound ~= nil and reverseDriveSound ~= "" then
        reverseDriveSound = Utils.getFilename(reverseDriveSound, self.baseDirectory);
        self.reverseDriveSound = createSample("reverseDriveSound");
        self.reverseDriveSoundEnabled = false;
        loadSample(self.reverseDriveSound, reverseDriveSound, false);
        self.reverseDriveSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.reverseDriveSound#volume"), 1.0);
    end;
    

    self.isMotorStarted = false;

    self.exhaustParticleSystems = {};
    local exhaustParticleSystemCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.exhaustParticleSystems#count"), 0);
    for i=1, exhaustParticleSystemCount do
        local namei = string.format("vehicle.exhaustParticleSystems.exhaustParticleSystem%d", i);
        Utils.loadParticleSystem(xmlFile, self.exhaustParticleSystems, namei, self.components, false, nil, self.baseDirectory)
    end;

    self.lastRoundPerMinute = 0;

    -- Steerable
    self.keys = {};
    local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
        local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
            break;
        end;
        self.keys[inputName] = Input[inputKey];
        i = i+1;
    end;

    self.onEnter = SpecializationUtil.callSpecializationsFunction("onEnter");
    self.onLeave = SpecializationUtil.callSpecializationsFunction("onLeave");
    self.drawGrainLevel = SpecializationUtil.callSpecializationsFunction("drawGrainLevel");


    self.enterReferenceNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.enterReferenceNode#index"));
    self.exitPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.exitPoint#index"));


    self.steering = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.steering#index"));
    if self.steering ~= nil then
        self.steeringSpeed = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.steering#rotationSpeed"), 0);
    end;

    -- Cameras
    self.numCameras = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.cameras#count"), 0);
    if self.numCameras == 0 then
        print("Error: no cameras in xml file: ", configFile);
    end;
    self.cameras = {};
    for i=1, self.numCameras do
        local cameranamei = string.format("vehicle.cameras.camera%d", i);
        local camIndexStr = getXMLString(xmlFile, cameranamei .. "#index");
        local cameraNode = Utils.indexToObject(self.components, camIndexStr);
        local rotatable = getXMLBool(xmlFile, cameranamei .. "#rotatable");
        local limit = getXMLBool(xmlFile, cameranamei .. "#limit");
        local rotMinX = getXMLFloat(xmlFile, cameranamei .. "#rotMinX");
        local rotMaxX = getXMLFloat(xmlFile, cameranamei .. "#rotMaxX");
        local transMin = getXMLFloat(xmlFile, cameranamei .. "#transMin");
        local transMax = getXMLFloat(xmlFile, cameranamei .. "#transMax");
        local rotateNode = "";
        if rotatable then
            rotateNode = Utils.indexToObject(self.components, getXMLString(xmlFile, cameranamei .. "#rotateNode"));
        end;
        self.cameras[i] = VehicleCamera:new(cameraNode, rotatable, rotateNode, limit, rotMinX, rotMaxX, transMin, transMax);
    end;

    self.camIndex = 1;

    self.tipCamera = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.tipCamera#index"));
    
    -- Character node
    self.characterNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.characterNode#index"));
    if self.characterNode ~= nil then
        self.characterCameraMinDistance = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.characterNode#cameraMinDistance"), 1.5);
        setVisibility(self.characterNode, false);
    end;

    -- Lights
    self.numLights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.lights#count"), 0);
    self.lightObjects = {};
    for i=1, self.numLights do
        local lightnamei = string.format("vehicle.lights.light" .. "%d", i);
        self.lightObjects[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, lightnamei .. "#index"));
        setVisibility(self.lightObjects[i], false);
    end;
    self.lightsActive = false;

    -- Low beam lights
    self.lowLightsObject = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.utilLights.lowBeam#index"));
    setVisibility(self.lowLightsObject, false);
    self.lowLightsActive = false;
    
    -- High beam lights
    self.highLightsObject = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.utilLights.highBeam#index"));
    setVisibility(self.highLightsObject, false);
    self.highLightsActive = false;
    
    -- Revers lights
    self.reverseLightObject = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.utilLights.reverse#index"));
    setVisibility(self.reverseLightObject, false);
    self.reverseLightActive = false;
    
    -- Brake lights
    self.brakeLightObject = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.utilLights.brake#index"));
    setVisibility(self.brakeLightObject, false);
    self.brakeLightActive = false;
    
    -- Dashboard
    self.rotateNeedle = SpecializationUtil.callSpecializationsFunction("rotateNeedle");
    self.PI = math.pi;
    self.PI_2 = math.pi / 2;
    --RPM
    self.rpmNeedle = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.dashboard.rpm#index"));
    self.rpmNeedleMin = math.rad(Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.dashboard.rpm#min")));
    self.rpmNeedleMax = math.rad(Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.dashboard.rpm#max")));
    self.rpmLastValue = 0;
    
    --Speed
    self.speedNeedle = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.dashboard.speed#index"));
    self.speedNeedleMin = math.rad(Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.dashboard.speed#min")));
    self.speedNeedleMax = math.rad(Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.dashboard.speed#max")));
    self.speedLastValue = 0;
    self.maxSpeed = 68;
    
    --Fuel
    self.fuelNeedle = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.dashboard.fuel#index"));
    self.fuelNeedleMin = math.rad(Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.dashboard.fuel#min")));
    self.fuelNeedleMax = math.rad(Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.dashboard.fuel#max")));
    self.fuelLastValue = 0;    

    -- Other variables
    self.speedRotScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.speedRotScale#scale"), 80);
    self.speedRotScaleOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.speedRotScale#offset"), 0.7);
    self.isEntered = false;
    self.steeringEnabled = true;
    self.ignition = false;
    self.disableCharacterOnLeave = true;
    self.deactivateOnLeave = true;
    self.stopRefuelOnLeave = true;
    self.deactivateLightsOnLeave = true;
    self.showWaterWarning = false;
    self.waterSplashSample = nil;
    
    -- HUD
    self.hudBasePoxX = 0.8325;
    self.hudBasePoxY = (1-0.99);
    self.hudBaseWidth = 0.16;
    self.hudBaseHeight = 0.17;
    self.hudBaseOverlay = Overlay:new("hudBaseOverlay", "dataS/missions/hud_vehicle_base".. g_languageSuffix .. ".png", self.hudBasePoxX, self.hudBasePoxY, self.hudBaseWidth, self.hudBaseHeight);
    self.logoFile = Utils.getFilename("textures/Tatra_logo.png", self.baseDirectory);
    self.hudLogoWidth = 0.0312;
    self.hudLogoHeight = 0.05;
    self.hudLogoPoxX = 0.075;
    self.hudLogoPoxY = 0.435;
    self.hudLogoOverlay = Overlay:new("hudLogoOverlay", self.logoFile, self.hudLogoPoxX, self.hudLogoPoxY, self.hudLogoWidth, self.hudLogoHeight);
end;

function TatraAgro:delete()
	for k, interiorlight in pairs(self.interiorlights) do
		setVisibility(interiorlight, false);
	end;
	self.interiorlightsActive = false;

    for i=1, table.getn(self.cameras) do
        self.cameras[i]:delete();
    end;

    if self.hudBaseOverlay then
        self.hudBaseOverlay:delete();
    end;
    
    if self.hudLogoOverlay then
        self.hudLogoOverlay:delete();
    end;
end;

function TatraAgro:mouseEvent(posX, posY, isDown, isUp, button)
    self.cameras[self.camIndex]:mouseEvent(posX, posY, isDown, isUp, button);
end;

function TatraAgro:keyEvent(unicode, sym, modifier, isDown)

    if InputBinding.isPressed(InputBinding.ZRCATKA) then 
    	self.drawMirror = not self.drawMirror;
    	setVisibility(self.mirrors[1], self.drawMirror);
    	setVisibility(self.mirrors[2], self.drawMirror);
    end;

	if isDown and sym == Input.KEY_KP_1 then 
		self.flashLeft = not self.flashLeft;
		self.delayOnLeft = 10;
		self.flashRight = false;
		self.flash = false;
		self.indexjActive = false;
	end;

	if isDown and sym == Input.KEY_KP_3 then 
		self.flashRight = not self.flashRight;
		self.delayOnRight = 10;
		self.flashLeft = false;
		self.flash = false;
		self.indexbActive = false;
	end;
	if isDown and sym == Input.KEY_KP_2 then 
		self.flash = not self.flash;
		self.flashRight = false;
		self.flashLeft = false;
		self.delayOn = 20;
		self.indexjActive = false;
		self.indexbActive = false;
	end;
    if InputBinding.isPressed(InputBinding.VYKYR) then 
		self.rotationMaxvykyr = not self.rotationMaxvykyr;
	end;
    if InputBinding.isPressed(InputBinding.KABINA) then 
		self.rotationMaxkabina = not self.rotationMaxkabina;
	end;
    if InputBinding.isPressed(InputBinding.OKNORIGHTSMALL) then 
		self.rotationMaxoknorightsmall = not self.rotationMaxoknorightsmall;
	end;
    if InputBinding.isPressed(InputBinding.OKNOLEFTSMALL) then 
		self.rotationMaxoknoleftsmall = not self.rotationMaxoknoleftsmall;
	end;
    if InputBinding.isPressed(InputBinding.OKNORIGHT) then 
			self.oknorightmax = not self.oknorightmax;
	end;
    if InputBinding.isPressed(InputBinding.OKNOLEFT) then 
			self.oknoleftmax = not self.oknoleftmax;
	end;
    if InputBinding.isPressed(InputBinding.MASKA) then 
		self.rotationMaxmaska = not self.rotationMaxmaska;
	end; 
    if InputBinding.isPressed(InputBinding.RIGHTDOOR) then
		self.rotationMaxrightdoor = not self.rotationMaxrightdoor;
	end; 
    if InputBinding.isPressed(InputBinding.LEFTDOOR) then 
		self.rotationMaxleftDoor = not self.rotationMaxleftDoor;
	end;

    -- Low and high beam lights
    if InputBinding.isPressed(InputBinding.TOGGLE_LIGHTS) then
        if not self.lightsActive then
            self.lightsActive = true;
			self.lowLightsActive = true;
		elseif self.lowLightsActive then
			self.highLightsActive = true;
			self.lowLightsActive = false;
		elseif self.highLightsActive then
			self.highLightsActive = false;
			self.lightsActive = false;
		end;
    end;

    -- Display help text
    if InputBinding.isPressed(InputBinding.HELP) then
        self.helpPanel = not self.helpPanel;
    end;
    
    -- Manual ignition
    if InputBinding.isPressed(InputBinding.IGNITION) then
        self.ignition = not self.ignition;
    end;
end;

function TatraAgro:update(dt)
--klakson
    if self:getIsActiveForInput() and self:getIsActiveForSound() and InputBinding.isPressed(InputBinding.HORN) then
        if not self.hornPlaying then
            playSample(self.hornSoundId, 0, 1, 0);
            self.hornPlaying = true;
        end;
    else
        if self.hornPlaying then
            stopSample(self.hornSoundId);
            self.hornPlaying = false;
        end;
    end;
--klakson
    -- Handle refueling
    self.doRefuel = self.doRefuel and self.hasRefuelStationInRange;
    if self.doRefuel then
        if not self.refuelSampleRunning and self:getIsActiveForSound() then
            playSample(self.refuelSample, 0, 1, 0);
            self.refuelSampleRunning = true;
        end;

        local refuelSpeed = 0.01;
        local currentFillLevel = self.fuelFillLevel;
        self:setFuelFillLevel(self.fuelFillLevel+refuelSpeed*dt);
        local delta = (self.fuelFillLevel-currentFillLevel);

        if delta <= 0.05 then
            self.doRefuel = false;
        end;

        delta = delta * g_fuelPricePerLiter;

        g_currentMission.missionStats.expensesTotal = g_currentMission.missionStats.expensesTotal + delta;
        g_currentMission.missionStats.expensesSession = g_currentMission.missionStats.expensesSession + delta;
        g_currentMission.missionStats.money = g_currentMission.missionStats.money - delta;
    else
        if self.refuelSampleRunning then
            stopSample(self.refuelSample);
            self.refuelSampleRunning = false;
        end;
    end;
    
    -- Define input
    if self:getIsActiveForInput() then
        self.input = InputBinding.getAnalogInputAxis(InputBinding.AXIS_FORWARD);
        if InputBinding.isAxisZero(self.input) then
            self.input = InputBinding.getDigitalInputAxis(InputBinding.AXIS_FORWARD);
        end;
        -- Turn on the engine when pressing the accelerator
        if math.abs(self.input) > 0.3 and not self.isMotorStarted then
            self.ignition = true;
        end;
    end;
    
    -- Handle engine sounds 
    if self.isMotorStarted then
        if self:getIsActiveForSound() then
            if self.playMotorSound then
                if self.motorSound ~= nil and self.playMotorSoundTime <= self.time then
                    playSample(self.motorSound, 0, self.motorSoundVolume, 0);
                    self.playMotorSound = false;
                    if self.motorSoundRun ~= nil then
                        playSample(self.motorSoundRun, 0, 0.0, 0);
                    end;
                end;
            end;
            if self.compressionSound ~= nil and self.compressionSoundTime < self.time then
                playSample(self.compressionSound, 1, self.compressionSoundVolume, 0);
                setSamplePitch(self.compressionSound, self.compressionSoundPitchOffset);
                self.compressionSoundTime = self.time + 180000;
                self.compressionSoundEnabled = true;
            end;
        end;

        if table.getn(self.wheels) > 0 then
            local alpha = 0.9;
            local roundPerMinute = self.lastRoundPerMinute*alpha + (1-alpha)*(self.motor.lastMotorRpm-self.motor.minRpm);
            self.lastRoundPerMinute = roundPerMinute;
            local roundPerSecond = roundPerMinute / 60;

            if self.motorSound ~= nil then
                setSamplePitch(self.motorSound, math.min(self.motorSoundPitchOffset + 
                  self.motorSoundPitchScale*math.abs(roundPerSecond), self.motorSoundPitchMax));
                if self.motorSoundRun ~= nil then
                    setSamplePitch(self.motorSoundRun, math.min(self.motorSoundRunPitchOffset + 
                      self.motorSoundRunPitchScale*math.abs(roundPerSecond), self.motorSoundRunPitchMax));
                end;
            end;
            
            if self.compressedAirSound ~= nil then
                if self.input == -1 and self.compressedAirSoundEnabled then
                    self.compressedAirSoundEnabled = false;
                end;
                if self.input == 1 and not self.compressedAirSoundEnabled then
                    if self:getIsActiveForSound() then
                        playSample(self.compressedAirSound, 1, self.compressedAirSoundVolume, 0);
                        setSamplePitch(self.compressedAirSound, self.compressedAirSoundPitchOffset);
                    end;
                    self.compressedAirSoundEnabled = true;
                end;
            end;
            
            if self.reverseDriveSound ~= nil then
                if self.movingDirection == -1 then
                    if not self.reverseDriveSoundEnabled and self:getIsActiveForSound() then
                        playSample(self.reverseDriveSound, 0, self.reverseDriveSoundVolume, 0);
                        self.reverseDriveSoundEnabled = true;
                    end;
                else
                    if self.reverseDriveSoundEnabled then
                        stopSample(self.reverseDriveSound);
                        self.reverseDriveSoundEnabled = false;
                    end;
                end;
            end;

            if self.motorSoundRun ~= nil then
                local maxRpm  = self.motorMaxRpmLimit[3];
                if self.input ~= 0 or self.motor.speedLevel ~= 0 then
                    local rpmVolume = Utils.clamp(math.abs(roundPerMinute)/((maxRpm - self.motor.minRpm)), 0.0, 1.0);
                    setSampleVolume(self.motorSoundRun, rpmVolume);
                else
                    local rpmVolume = Utils.clamp(math.abs(roundPerMinute)/((maxRpm - self.motor.minRpm)*2), 0.0, 1.0);
                    setSampleVolume(self.motorSoundRun, rpmVolume);
                end;
            end;
        end;
    end;

    if self:getIsActive() then
        if self.steering ~= nil then
            setRotation(self.steering, 0, self.rotatedTime*self.steeringSpeed, 0);
        end;

        local xt,yt,zt = getTranslation(self.components[1].node);
        local deltaWater = yt-g_currentMission.waterY+2.5;
        if deltaWater < 0 then
            self.isBroken = true;
            g_currentMission:onSunkVehicle();
            if self.isEntered then
                g_currentMission:onLeaveVehicle();
                if self:getIsActiveForSound() then
                    local volume = math.min(1, self.lastSpeed*3600/30);
                    if self.waterSplashSample == nil then
                        self.waterSplashSample = createSample("waterSplashSample");
                        loadSample(self.waterSplashSample, "data/maps/sounds/waterSplash.wav", false);
                    end;
                    playSample(self.waterSplashSample, 1, volume, 0);
                end;
            end;
        end;
        self.showWaterWarning = deltaWater < 2;
    end;

    if self.isEntered then
        if self.isMotorStarted and self.rotorFan2 ~= nil then
          rotate(self.rotorFan2, dt*0, 0, 1);
        end;
--blinkry
        if self.indexeb ~= nil and self.indexhb ~= nil then
            if self.indexbActive then
            	setVisibility(self.indexeb, self.indexbActive);
            	setVisibility(self.indexhb, self.indexbActive);
	    else
            	setVisibility(self.indexeb, self.indexbActive);
            	setVisibility(self.indexhb, self.indexbActive);
	    end;
        end;

        if self.indexej ~= nil and self.indexhj ~= nil then
            if self.indexjActive then
            	setVisibility(self.indexej, self.indexjActive);
            	setVisibility(self.indexhj, self.indexjActive);
	    else
            	setVisibility(self.indexej, self.indexjActive);
            	setVisibility(self.indexhj, self.indexjActive);
	    end;
        end;

	if self.flashLeft then
		if self.delayOnLeft >= -1 then
			self.delayOnLeft = self.delayOnLeft -dt;
		end;
		if not self.indexbActive then
			if self.delayOnLeft < 0 then
				self.delayOffLeft = 500;
				self.indexbActive = true;
				playSample(self.turn1SoundId, 1, 0.7, 0);
			end;
		end;
		if self.delayOffLeft >= 0 then
			self.delayOffLeft = self.delayOffLeft -dt;
		end;
		if self.indexbActive then
			if self.delayOffLeft < 0 then
				self.delayOnLeft = 500;
				self.indexbActive = false;
				playSample(self.turn2SoundId, 1, 0.7, 0);
			end;
		end;
	end;

	if self.flashRight then
		if self.delayOnRight >= 0 then
			self.delayOnRight = self.delayOnRight -dt;
		end;
		if not self.indexjActive then
			if self.delayOnRight < 0 then
				self.delayOffRight = 500;
				self.indexjActive = true;
				playSample(self.turn1SoundId, 1, 0.7, 0);
			end;
		end;
		if self.delayOffRight >= 0 then
			self.delayOffRight = self.delayOffRight -dt;
		end;
		if self.indexjActive then
			if self.delayOffRight < 0 then
				self.delayOnRight = 500;
				self.indexjActive = false;
				playSample(self.turn2SoundId, 1, 0.7, 0);
			end;
		end;
	end;

	if self.flash then
		if self.delayOn >= 0 then
			self.delayOn = self.delayOn -dt;
		end;
		if not self.indexjActive then
			if self.delayOn < 0 then
				self.delayOff = 500;
				self.indexjActive = true;
				self.indexbActive = true;
				playSample(self.turn1SoundId, 1, 0.7, 0);
			end;
		end;
		if self.delayOff >= 0 then
			self.delayOff = self.delayOff -dt;
		end;
		if self.indexjActive then
			if self.delayOff < 0 then
				self.delayOn = 500;
				self.indexbActive = false;
				self.indexjActive = false;
				playSample(self.turn2SoundId, 1, 0.7, 0);
			end;
		end;
	end;

	if not self.flashLeft and not self.flashRight then
		if not self.flash then
			self.indexjActive = false;
			self.indexbActive = false;
		end;
	end;
		
	if not self.flash and not self.flashLeft then
		if not self.flashRight then
			self.indexjActive = false;
		end;
	end;

	if not self.flash and not self.flashRight then
		if not self.flashLeft then
			self.indexbActive = false;
		end;
	end;
--blinkry
--interior light
		if InputBinding.hasEvent(InputBinding.INTERIORLIGHTS) then
			self.interiorlightsActive = not self.interiorlightsActive;
		end;
	
		for k, interiorlight in pairs(self.interiorlights) do
			setVisibility(interiorlight, self.interiorlightsActive);
		end;
--interior light
--vykyr
	    if self.rotationPartvykyr ~= nil then
		   local x, y, z = getRotation(self.rotationPartvykyr.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartvykyr.maxRot, self.rotationPartvykyr.minRot, 3, self.rotationPartvykyr.rotTime, dt, not self.rotationMaxvykyr);
		   setRotation(self.rotationPartvykyr.node, unpack(newRot));
        end;
--vykyr
--kabina
	    if self.rotationPartkabina ~= nil then
		   local x, y, z = getRotation(self.rotationPartkabina.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartkabina.maxRot, self.rotationPartkabina.minRot, 3, self.rotationPartkabina.rotTime, dt, not self.rotationMaxkabina);
		   setRotation(self.rotationPartkabina.node, unpack(newRot));
        end;
--kabina
	    if self.rotationPartoknorightsmall ~= nil then
		   local x, y, z = getRotation(self.rotationPartoknorightsmall.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartoknorightsmall.maxRot, self.rotationPartoknorightsmall.minRot, 3, self.rotationPartoknorightsmall.rotTime, dt, not self.rotationMaxoknorightsmall);
		   setRotation(self.rotationPartoknorightsmall.node, unpack(newRot));
        end;

	    if self.rotationPartoknoleftsmall ~= nil then
		   local x, y, z = getRotation(self.rotationPartoknoleftsmall.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartoknoleftsmall.maxRot, self.rotationPartoknoleftsmall.minRot, 3, self.rotationPartoknoleftsmall.rotTime, dt, not self.rotationMaxoknoleftsmall);
		   setRotation(self.rotationPartoknoleftsmall.node, unpack(newRot));
        end;

   if self.oknorightmax ~= nil then
		local x, y, z = getTranslation(self.oknoright.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.oknoright.maxTrans, self.oknoright.minTrans, 3, self.oknoright.transTime, dt, not self.oknorightmax);
        setTranslation(self.oknoright.node, unpack(newTrans));
		end;

   if self.oknoleftmax ~= nil then
		local x, y, z = getTranslation(self.oknoleft.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.oknoleft.maxTrans, self.oknoleft.minTrans, 3, self.oknoleft.transTime, dt, not self.oknoleftmax);
        setTranslation(self.oknoleft.node, unpack(newTrans));
		end;

	    if self.rotationPartmaska ~= nil then
		   local x, y, z = getRotation(self.rotationPartmaska.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartmaska.maxRot, self.rotationPartmaska.minRot, 3, self.rotationPartmaska.rotTime, dt, not self.rotationMaxmaska);
		   setRotation(self.rotationPartmaska.node, unpack(newRot));
        end;

        if self.rotationPartleftDoor ~= nil then
		   local x, y, z = getRotation(self.rotationPartleftDoor.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartleftDoor.maxRot, self.rotationPartleftDoor.minRot, 3, self.rotationPartleftDoor.rotTime, dt, not self.rotationMaxleftDoor);
		   setRotation(self.rotationPartleftDoor.node, unpack(newRot));
        end;
    
	    if self.rotationPartrightdoor ~= nil then
		   local x, y, z = getRotation(self.rotationPartrightdoor.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartrightdoor.maxRot, self.rotationPartrightdoor.minRot, 3, self.rotationPartrightdoor.rotTime, dt, not self.rotationMaxrightdoor);
		   setRotation(self.rotationPartrightdoor.node, unpack(newRot));
        end;
        if InputBinding.hasEvent(InputBinding.REFUEL) then
            if self.doRefuel then
                self:stopRefuel();
            else
                self:startRefuel();
            end;
        end;

        if self.characterNode ~= nil then
            local cx, cy, cz = getWorldTranslation(self.characterNode);
            local x,y,z = getWorldTranslation(getCamera());
            local dist = Utils.vector3Length(cx-x, cy-y, cz-z);
            if dist < self.characterCameraMinDistance then
                setVisibility(self.characterNode, false);
            else
                setVisibility(self.characterNode, true);
            end;
        end;

        if not g_currentMission.fixedCamera then
            setCamera(self.cameras[self.camIndex].cameraNode);
            self.cameras[self.camIndex]:update(dt);
        else
            if self.tipCamera ~= nil then
                setCamera(self.tipCamera);
            else
                self.cameras[self.camIndex]:resetCamera();
            end;
        end;

        -- Mutes stop sound when engine is off
        if not self.ignition or not self.deactivateOnLeave then
            self.motorStopSoundVolume = 0;
        else
            self.motorStopSoundVolume = self.motorStopSoundVolumeBU;
        end;

        if self.ignition and not self.isMotorStarted then
            self:startMotor();
            self.deactivateOnLeave = false;
            self.steeringEnabled = true;
        elseif not self.ignition and self.isMotorStarted then
            if self.motorStopSoundVolume == 0 then
                self.motorStopSoundVolume = self.motorStopSoundVolumeBU;
            end;

            self:stopMotor();
            self.steeringEnabled = false;
            self.deactivateOnLeave = true;
            setVisibility(self.aiMotorSound, false);

            self:onDeactivateAttachements();
        end;
        if not self.isMotorStarted then
            -- Brakes the wheels upon turning off the engine
            self.motor.brakeForce = 50
            for k,wheel in pairs(self.wheels) do
                setWheelShapeProps(wheel.node, wheel.wheelShape, 0, self.motor.brakeForce, 0);
            end;
        end;

        if self.steeringEnabled then
            local fuelUsed = self.lastMovedDistance*self.fuelUsage;
            self:setFuelFillLevel(self.fuelFillLevel-fuelUsed);

            g_currentMission.missionStats.fuelUsageTotal = g_currentMission.missionStats.fuelUsageTotal + fuelUsed;
            g_currentMission.missionStats.fuelUsageSession = g_currentMission.missionStats.fuelUsageSession + fuelUsed;
            g_currentMission.missionStats.traveledDistanceTotal = g_currentMission.missionStats.traveledDistanceTotal + self.lastMovedDistance*0.001;
            g_currentMission.missionStats.traveledDistanceSession = g_currentMission.missionStats.traveledDistanceSession + self.lastMovedDistance*0.001;

            local acceleration = 0;
            if g_currentMission.allowSteerableMoving and not self.playMotorSound then
                acceleration = -InputBinding.getAnalogInputAxis(InputBinding.AXIS_FORWARD);
                if InputBinding.isAxisZero(acceleration) then
                    acceleration = -InputBinding.getDigitalInputAxis(InputBinding.AXIS_FORWARD);
                end;
                if math.abs(acceleration) > 0.8 then
                    self.motor:setSpeedLevel(0, true)
                end;
                if self.motor.speedLevel ~= 0 then
                    acceleration = 1.0;
                end;
            end;
            
			if self.input == -1 then
				self.motor:setSpeedLevel(0,true)
				self.motor.brakeForce = 0;
			end;
			if self.input == 1 or (self.movingDirection < 0 and self.input == -1) then
				self.motor:setSpeedLevel(0, true)
				self.motor.brakeForce = 50;
			end;
			
			if self.fuelFillLevel == 0 then
                acceleration = 0;
            end;
            
            -- Steering
            local inputAxisX = InputBinding.getAnalogInputAxis(InputBinding.AXIS_SIDE);
            if not InputBinding.isAxisZero(inputAxisX) then
                if inputAxisX < 0 then
                    self.rotatedTime = math.min(-self.maxRotTime*inputAxisX, self.maxRotTime);
                else
                    self.rotatedTime = math.max(self.minRotTime*inputAxisX, self.minRotTime);
                end;
            else
                local rotScale = math.min(1.0/(self.lastSpeed*self.speedRotScale+self.speedRotScaleOffset), 1);
                local inputAxisX = InputBinding.getDigitalInputAxis(InputBinding.AXIS_SIDE);
                if inputAxisX < 0 then
                    self.rotatedTime = math.min(self.rotatedTime - dt/1000*inputAxisX*rotScale, self.maxRotTime);
                elseif inputAxisX > 0 then
                    self.rotatedTime = math.max(self.rotatedTime - dt/1000*inputAxisX*rotScale, self.minRotTime);
                else
                    if self.autoRotateBackSpeed ~= 0 then
                        if self.rotatedTime > 0 then
                            self.rotatedTime = math.max(self.rotatedTime - dt/1000*self.autoRotateBackSpeed*rotScale, 0);
                        else
                            self.rotatedTime = math.min(self.rotatedTime + dt/1000*self.autoRotateBackSpeed*rotScale, 0);
                        end;
                    end;
                end;
            end;
            if self.firstTimeRun then
                WheelsUtil.updateWheelsPhysics(self, dt, self.lastSpeed, acceleration, false, self.requiredDriveMode)
            end;
        end;
        
        -- Dashboard
        if self.camIndex == 2 then
            -- RPM
            local rpmValue = 0;
            if self.isMotorStarted then
                rpmValue = self.motor.lastMotorRpm;
            end;
            if rpmValue ~= self.rpmLastValue then
                rpmPerc = rpmValue / self.motorMaxRpmLimit[3];
                self:rotateNeedle(self.rpmNeedle, rpmPerc, self.rpmNeedleMin, self.rpmNeedleMax);
                self.rpmLastValue = rpmValue;
            end;
            -- Speed
            local speedValue = 0;
            if self.isMotorStarted then
                speedValue = self.lastSpeed*self.speedDisplayScale*3600;
            end;
            if speedValue ~= self.speedLastValue then
                speedPerc = speedValue / self.maxSpeed;
                self:rotateNeedle(self.speedNeedle, speedPerc, self.speedNeedleMin, self.speedNeedleMax);
                self.speedLastValue = speedValue;
            end;
            -- Fuel
            local fuelValue = 0;
            if self.isMotorStarted then
                fuelValue = self.fuelFillLevel;
            else
                fuelValue = 0;
            end;
            if fuelValue ~= self.speedLastValue then
                fuelPerc = fuelValue / self.fuelCapacity;
                self:rotateNeedle(self.fuelNeedle, fuelPerc, self.fuelNeedleMin, self.fuelNeedleMax);
                self.fuelLastValue = fuelValue;
            end;
        end;
        
        -- Implement switching
        if InputBinding.hasEvent(InputBinding.SWITCH_IMPLEMENT) then
            local selected = self.selectedImplement;
            local numImplements = table.getn(self.attachedImplements);
            if selected ~= 0 and numImplements > 1 then
                selected = selected+1;
                if selected > numImplements then
                    selected = 1;
                end;
                self:setSelectedImplement(selected);
            end;
        end;

        -- Change camera
        if not g_currentMission.fixedCamera then
            if InputBinding.hasEvent(InputBinding.CAMERA_SWITCH) then
                self.cameras[self.camIndex]:onDeactivate();
                self.camIndex = self.camIndex + 1;
                if self.camIndex > self.numCameras then
                    self.camIndex = 1;
                end;
                self.cameras[self.camIndex]:onActivate();
            end;
        end;
        
        -- Low and high beam lights
        for i=1, self.numLights do
            setVisibility(self.lightObjects[i], self.lightsActive);
		end;
		setVisibility(self.lowLightsObject, self.lowLightsActive);
        setVisibility(self.highLightsObject, self.highLightsActive);

        -- Brake lights                
        if (self.movingDirection*self.lastSpeed*(-self.input)) < -0.001 then
            self.brakeLightActive = true;
        else
            self.brakeLightActive = false;
        end;
        setVisibility(self.brakeLightObject, self.brakeLightActive);
        
        -- Reverse lights
        if self.movingDirection < 0 then
            self.reverseLightActive = true;
        else
            self.reverseLightActive = false;
        end;
        setVisibility(self.reverseLightObject, self.reverseLightActive);

        -- Speed levels
        if InputBinding.hasEvent(InputBinding.SPEED_LEVEL1) then
            self.motor:setSpeedLevel(1, false);
        elseif InputBinding.hasEvent(InputBinding.SPEED_LEVEL2) then
            self.motor:setSpeedLevel(2, false);
        elseif InputBinding.hasEvent(InputBinding.SPEED_LEVEL3) then
            self.motor:setSpeedLevel(3, false);
        end;

        -- Attach trailer
        if InputBinding.hasEvent(InputBinding.ATTACH) then
            self:handleAttachEvent();
        end;

        if InputBinding.hasEvent(InputBinding.LOWER_IMPLEMENT) then
            self:handleLowerImplementEvent();
        end;

	end;
	
end;

function TatraAgro:onEnter()
    self.isEntered = true;
    self.camIndex = 1;
    self.cameras[self.camIndex]:onActivate();
    if self.ignition then
        self.steeringEnabled = true;
        self:startMotor();
    else
        self.isMotorStarted = false;
        Motorized.stopSounds(self);
        self.steeringEnabled = false;
    end;
    if self.characterNode ~= nil then
        setVisibility(self.characterNode, true);
    end;
    -- Stop motor sound
    setVisibility(self.aiMotorSound, false);
    self:onActivateAttachements();
end;

function TatraAgro:onLeave()
    self.indexjActive = false;
    self.indexbActive = false;
    self.flash = false;
    self.flashRight = false;
    self.flashLeft = false;
    self.lighton = false;

    setVisibility(self.indexej, self.indexjActive);
    setVisibility(self.indexhj, self.indexjActive);
    setVisibility(self.indexeb, self.indexbActive);
    setVisibility(self.indexhb, self.indexbActive);

	for k, interiorlight in pairs(self.interiorlights) do
		setVisibility(interiorlight, false);
	end;
	self.interiorlightsActive = false;

    self.lightsActive = false;
    self.highLightsActive = false;
    self.lowLightsActive = false;
    setVisibility(self.highLightsObject, false);
    setVisibility(self.lowLightsObject, false);

    self.helpPanel = false;
    self.cameras[self.camIndex]:onDeactivate();
    self.motor.brakeForce = 50;

    if self.stopRefuelOnLeave then
        self:stopRefuel();
    end;

    if self.deactivateLightsOnLeave then
        self:setLightsVisibility(false);
    end;

    if self.characterNode ~= nil then
        if self.disableCharacterOnLeave then
            setVisibility(self.characterNode, false);
        else
            setVisibility(self.characterNode, true);
        end;
    end;

    if self.deactivateOnLeave then
        self:stopMotor();
        self.ignition = false;
        self.isMotorStarted = false;
        self:onDeactivateAttachements();
    else
        self.isMotorStarted = true;
        self.ignition = true;
        self.steeringEnabled = false;
        Motorized.stopSounds(self);
        -- Play motor sound
        setVisibility(self.aiMotorSound, true);
        if self.deactivateLightsOnLeave then
            self:onDeactivateAttachementsLights();
        end;
        self:onDeactivateAttachementsSounds();
    end;
    for k,wheel in pairs(self.wheels) do
        setWheelShapeProps(wheel.node, wheel.wheelShape, 0, self.motor.brakeForce, 0);
    end;
    self.isEntered = false;
end;

function TatraAgro:draw()
    setTextColor(1,1,1,1);
   if not self.helpPanel then
      renderText(0.7, 0.86, 0.021, "Num 0: Zobrazit Napovedu");
   else
      renderText(0.7, 0.86, 0.021, "Num 0: Skryt Napovedu");
   end;
   if self.helpPanel then
        self.hudLogoOverlay:render();
      renderText(0.01, 0.41, 0.023, "Tatra T815");
      renderText(0.01, 0.38, 0.015, "F: Svtla Vypnout/Tlumena/Dalkova");
      renderText(0.01, 0.37, 0.015, "Num 1: Levy Blinkr");
      renderText(0.01, 0.36, 0.015, "Num 3: Pravy Blinkr");
      renderText(0.01, 0.35, 0.015, "Num 2: Vstrazne Blinkry");
      renderText(0.01, 0.34, 0.015, "Num 8: Vyk");
      renderText(0.01, 0.33, 0.015, "Num period: Nastartovat");
      renderText(0.01, 0.32, 0.015, "Num 4: Leve dvere");
      renderText(0.01, 0.31, 0.015, "Num 5: Maska");
      renderText(0.01, 0.30, 0.015, "Num 6: Prave dvere");
      renderText(0.01, 0.29, 0.015, "Num 7: Leve Okno");
      renderText(0.01, 0.28, 0.015, "Num 9: Prave Okno");
      renderText(0.01, 0.27, 0.015, "KEY 9: Leve Okno Male");
      renderText(0.01, 0.26, 0.015, "KEY 0: Prave Okno Male");
      renderText(0.01, 0.25, 0.015, "KEY 8: Sklopit kabinu");
      renderText(0.01, 0.24, 0.015, "KEY 7: Osvetleni interieru");
      renderText(0.01, 0.23, 0.015, "KEY H: Klakson");
      renderText(0.01, 0.22, 0.015, "KEY Page_UP: Zarazeni rychlosti");
      renderText(0.01, 0.21, 0.015, "KEY Page_Down: Podrazeni");
      renderText(0.01, 0.20, 0.015, "KEY Enter: Prepinani Automat/Manual");
      renderText(0.01, 0.19, 0.015, "KEY 4: Zrcatka skryt/Zobrazit");
   end;

    self.hudBaseOverlay:render();

    -- hudBasePoxX = 0.8325;
    -- hudBasePoxY = (1-0.99);
    -- hudBaseWidth = 0.16;
    -- hudBaseHeight = 0.17;
    
    setTextBold(true);
   
    local kmh = self.lastSpeed*self.speedDisplayScale*3600;

    setTextColor(1.0, 1.0, 1.0, 1.0);
    if kmh > 0 and kmh < 100 then
        renderText(self.hudBasePoxX+0.007, self.hudBasePoxY+0.095, 0.06, string.format("%2d", kmh));
    end;
    renderText(self.hudBasePoxX+0.058, self.hudBasePoxY+0.094, 0.06, g_i18n:getText("speedometer"));
    renderText(self.hudBasePoxX+0.031, self.hudBasePoxY+0.071, 0.03, string.format("%d", g_currentMission.missionStats.money));

    local fuelWarn = 50;
    if self.fuelFillLevel < fuelWarn then
        setTextColor(1,0,0,1);
    end;
    renderText(self.hudBasePoxX+0.031, self.hudBasePoxY+0.039, 0.03, string.format("%d " .. g_i18n:getText("fluid_unit_long"), self.fuelFillLevel));
    if self.fuelFillLevel < fuelWarn then
        setTextColor(1,1,1,1);
    end;

    setTextBold(false);

    if self.hasRefuelStationInRange and not self.doRefuel and self.fuelFillLevel ~= self.fuelCapacity then
        g_currentMission:addHelpButtonText(g_i18n:getText("Refuel"), InputBinding.REFUEL);
        g_currentMission.hudFuelOverlay:render();
    end;

    if self.showWaterWarning then
        g_currentMission:addWarning(g_i18n:getText("Dont_drive_to_depth_into_the_water"), 0.05, 0.025+0.007);
    end;

    local trailerFillLevel, trailerCapacity = self:getAttachedTrailersFillLevelAndCapacity();
    if trailerFillLevel ~= nil and trailerCapacity ~= nil then
        self:drawGrainLevel(trailerFillLevel+self.fillLevel, trailerCapacity+self.capacity, 101);
    else
        self:drawGrainLevel(self.fillLevel, self.capacity, 101);
    end;
    if table.getn(self.attachedImplements) > 1 then
        g_currentMission:addHelpButtonText(g_i18n:getText("Change_tools"), InputBinding.SWITCH_IMPLEMENT);
    end;
end;

function TatraAgro:drawGrainLevel(level, capacity, warnPercent)

    local percent = 0;
    if capacity > 0 then
        percent = level/capacity*100;
    end;
    setTextBold(true);

    if percent >= warnPercent then
        setTextColor(1.0, 0.0, 0.0, 1.0);
    else
        setTextColor(1.0, 1.0, 1.0, 1.0);
    end;

    renderText(self.hudBasePoxX+0.031, self.hudBasePoxY+0.006, 0.03, string.format("%d(%d%%)", level, percent));
    if percent >= warnPercent then
        setTextColor(1.0, 1.0, 1.0, 1.0);
    end;
    setTextBold(false);
end;

function TatraAgro:startMotor()

    if not self.isMotorStarted then
        self.isMotorStarted = true;

        self.reverseDriveSoundEnabled = false;

        local motorSoundOffset = 0;
        if self.motorStartSound ~= nil and self:getIsActiveForSound() then
            playSample(self.motorStartSound, 1, self.motorStartSoundVolume, 0);
            setSamplePitch(self.motorStartSound, self.motorStartSoundPitchOffset);
            motorSoundOffset = getSampleDuration(self.motorStartSound);
        end;

        self.playMotorSound = true;
        self.playMotorSoundTime = self.time+motorSoundOffset;
        self.playCompressionSoundTime = self.time+motorSoundOffset;
        self.compressionSoundTime = self.time + 180000;

        self.lastRoundPerMinute=0;

        Utils.setEmittingState(self.exhaustParticleSystems, true)
    else
        self.playMotorSound = true;
    end;
end;

function TatraAgro:stopMotor()

    self.isMotorStarted = false;
    Motorized.stopSounds(self);

    if self:getIsActiveForSound() then
        if self.motorStopSound ~= nil then
            setSamplePitch(self.motorStopSound, self.motorStopSoundPitchOffset);
            playSample(self.motorStopSound, 1, self.motorStopSoundVolume, 0);
        end;
    end;

    self.motor:setSpeedLevel(0, false);

    Utils.setEmittingState(self.exhaustParticleSystems, false)
end;

function TatraAgro:stopSounds()

    self.playMotorSound = false;
    if self.motorSound ~= nil then
        stopSample(self.motorSound);
    end;

    self.playMotorRunSound = false;
    if self.motorSoundRun ~= nil then
        stopSample(self.motorSoundRun);
    end;

    if self.motorStartSound ~= nil then
        stopSample(self.motorStartSound);
    end;

    if self.compressionSoundEnabled then
        stopSample(self.compressionSound);
        self.compressionSoundEnabled = false;
    end;
end;

function TatraAgro:startRefuel()

    if self.hasRefuelStationInRange then
        self.doRefuel = true;
    end;
end;

function TatraAgro:stopRefuel()

    self.doRefuel = false;

    if self.refuelSampleRunning then
        stopSample(self.refuelSample);
        self.refuelSampleRunning = false;
    end;
end;


function TatraAgro:setFuelFillLevel(newFillLevel)
    self.fuelFillLevel = math.max(math.min(newFillLevel, self.fuelCapacity), 0);
end;


function TatraAgro:rotateNeedle(object, percent, min, max) 
    angle = min + (max - min) * percent;
    setRotation(object, self.PI, angle, self.PI_2);
end;